// Created by Michael Thornbury for P436

/* Simply connect by TCP, nearly identical to connectTCP, but without a need for a host */

#include "opensock.h"

sas* opensock(int);

int passiveTCP(int port, int qlen)
/* Sets up a listener connection to host:port */
{
  int sock;
  sas* socketandsin;

  socketandsin = opensock(port);

  if (bind(socketandsin->sock, (struct sockaddr *)&(socketandsin->sin), sizeof(socketandsin->sin)) < 0) {
     printf("Unable to bind to %i.\n", port);
     free(socketandsin);
     return -1;
  }

  if (listen(socketandsin->sock, qlen) < 0) {
     printf("Unable to listen to %i.\n", port);
     free(socketandsin);
     return -1;
  }
  sock = socketandsin->sock;
  // Important to free memory so clients don't waste memory.
  free(socketandsin);
  return sock;
}

